/*****************************************************************************/
/*       (C) 1993,1994 R. NADE - M. GRANDCHAMP - All Rights Reserved         */
/*****************************************************************************/
/*    This source-code is NOT public domain nor Freeware, this is part of    */
/*              'The C Programming Package' which is Shareware.              */
/*   If you use this code, please register and get a free Full-VGA version   */
/*****************************************************************************/
                               /*----------------*
                                *   CPPLMEN6.C   *
                                * Menu manager6  *
                                *----------------*/

 /* Included Files */
 # include <stdio.h>
 # include <io.h>
 # include <dos.h>
 # include <fcntl.h>
 # include <bios.h>
 # include <stdlib.h>
 # include <conio.h>

 /* Global Variables */
 extern int bm,i,j,k,l,m,n,t,x,x1,x2,xm,y,y1,y2,ym,z,menu0,menu6,return1;
 extern int colour1,colour2,colour3,colour4,colour5,returning;
 extern unsigned char c0,c1,trashcan[];

 /*----------------------*
  * CHOICE DISPLAY HELP6 *
  *----------------------*/
  void choice_display_help6()
    {
      /* We display the help that concerns the line on */
      /* which is the menu cursor (in red).            */
      if(menu6==1){
	/*  */
        display_help("MENU6   ",55,2,1);     restore_help_screen();
      }
      if(menu6==2){
	/*  */
        display_help("MENU6   ",56,3,1);     restore_help_screen();
      }
      if(menu6==3){
	/*  */
        display_help("MENU6   ",57,4,1);     restore_help_screen();
      }
      if(menu6==4){
	/*  */
        display_help("MENU6   ",58,5,1);     restore_help_screen();
      }
      if(menu6==5){
	/*  */
        display_help("MENU6   ",59,6,1);     restore_help_screen();
      }
      if(menu6==6){
	/*  */
        display_help("MENU6   ",60,7,1);     restore_help_screen();
      }
      if(menu6==7){
        /* available */
        display_help("MENU6   ",61,8,1);     restore_help_screen();
      }
      if(menu6==8){
	/*  */
        display_help("MENU6   ",62,9,1);     restore_help_screen();
      }
      if(menu6==9){
	/*  */
        display_help("MENU6   ",63,10,1);    restore_help_screen();
      }
      if(menu6==10){
	/*  */
        display_help("MENU6   ",64,11,1);    restore_help_screen();
      }
    }
 /*----------------*
  * GET THE MOUSE6 *
  *----------------*/
  int get_the_mouse6()
    {
      /* If we choose with the mouse */
      /* Only available  for menu 1  */
      if(ym==1){
        /* We clicked on the first line, certainly */
        /* To change of menu.                      */
        x=get_the_mouse0();
	menu0=x;                       return(-2);
      }
      if((xm>38)&&(xm<55)){
	if(ym==3){
	  /*  */
	  menu6=1;	               return(1);
	}
	if(ym==4){
	  /*  */
	  menu6=2;                     return(1);
	}
	if(ym==5){
	  /*  */
	  menu6=3;                     return(1);
	}
	if(ym==6){
	  /*  */
	  menu6=4;                     return(1);
	}
	if(ym==7){
	  /*  */
	  menu6=5;                     return(1);
	}
	if(ym==8){
	  /*  */
	  menu6=6;                     return(1);
	}
	if(ym==9){
	  /*  */
	  menu6=7;                     return(1);
	}
	if(ym==10){
	  /*  */
	  menu6=8;                     return(1);
	}
	if(ym==11){
	  /*  */
	  menu6=9;                     return(1);
	}
	if(ym==12){
	  /*  */
	  menu6=10;                    return(1);
	}
      }
      /* If we clicked outside the menu zone            */
      /* we want to erase the menu and return to menu 0 */
      /*  */
      menu0=0;                         return(-2);
    }
 /*--------------*
  * MENU CHOICE6 *
  *--------------*/
  int menu_choice6()
    {
      returning=wait_for_a_key();
      /* Else we pressed a keyboard key                            */
      /* Cf CPPLTC2.C for the keyboard test and the returned codes */
      if(returning==-1){
        /* <Esc> we want to go back to menu0 */
	menu0=0;                       return(-2);
      }
      if(returning==40){
        /* <Enter> execute the command */
	return(1);
      }
      if(returning==100){
        /* We pressed a mouse button */
        m=get_the_mouse6();  return(m);
      }
      /* The key letters depends on the menu  */

      /* So the below returns need to be modified */
      if(returning==24){
	/* <O> <o>  */
	menu6=1;                       return(1);
      }
      if(returning==23){
	/* <N> <n>  */
	menu6=2;                       return(1);
      }
      if(returning==28){
	/* <S> <s>  */
	menu6=3;                       return(1);
      }
      if(returning==13){
	/* <D> <d>  */
	menu6=5;                       return(1);
      }
      if(returning==27){
	/* <R> <r>  */
	menu6=6;                       return(1);
      }
      if(returning==18){
	/* <I> <i>  */
	menu6=7;                       return(1);
      }
      if(returning==15){
	/* <F> <f>  */
	menu6=8;                       return(1);
      }
      if(returning==26){
	/* <Q> <q>  */
	menu6=10;	               return(1);
      }
      /* For the 2-bytes coded keys, this is the second byte */
      if(returning==59){
         /* Function key <F1> = help */
	 return(59);
      }
      if(returning>100){
        /* We pressed Alt + another key to get a menu */
        c1=returning-100;                 k=get_special_menu00();
	if(k>0)                        return(-2);
      }
      if((returning==77)||(returning==75)){
        /* Left or Right arrow to change of menu */
        c1=returning;                             k=get_special_menu00();
	if(k>0)                        return(-2);
      }
      if(returning==72){
        /* Up arrow */
	if(menu6>1)                    menu6--;
	else                           menu6=10;
	return(0);
      }
      if(returning==80){
        /* Down arrow */
	if(menu6<10)                   menu6++;
	else                           menu6=1;
	return(0);
      }
      /* Else we return 0 = no choice */
      return(0);
    }
 /*--------------------*
  * DISPLAY LINE menu6 *
  *--------------------*/
  void display_menu_line6()
    {
      /* First we display the chosen menu0 */
      textattr(colour5);
      gotoxy(41,1);                    cputs("  Menu6  ");
      /* Same thing for the selected line */
      if(menu6==1){
	gotoxy(39,3);                  cputs("                ");
      }
      if(menu6==2){
	gotoxy(39,4);                  cputs("                ");
      }
      if(menu6==3){
	gotoxy(39,5);                  cputs("                ");
      }
      if(menu6==4){
	gotoxy(39,6);                  cputs("                ");
      }
      if(menu6==5){
	gotoxy(39,7);                  cputs("                ");
      }
      if(menu6==6){
	gotoxy(39,8);                  cputs("                ");
      }
      if(menu6==7){
	gotoxy(39,9);                  cputs("                ");
      }
      if(menu6==8){
	gotoxy(39,10);                 cputs("                ");
      }
      if(menu6==9){
	gotoxy(39,11);                 cputs("                ");
      }
      if(menu6==10){
	gotoxy(39,12);                 cputs("                ");
      }
    }
 /*----------------------*
  * DISPLAY KEY LETTER 6 *
  *----------------------*/
  void display_key_letter6()
    {
      textattr(116);
      gotoxy(40,3);                   cputs(" ");
      gotoxy(40,4);                   cputs(" ");
      gotoxy(40,5);                   cputs(" ");
      gotoxy(40,6);                   cputs(" ");
      gotoxy(40,7);                   cputs(" ");
      gotoxy(40,8);                   cputs(" ");
      gotoxy(40,9);                   cputs(" ");
      gotoxy(40,10);                  cputs(" ");
      gotoxy(40,11);                  cputs(" ");
      gotoxy(40,12);                  cputs(" ");
    }
 /*---------------*
  * DISPLAY menu6 *
  *---------------*/
  void display_menu6()
    {
      /* To avoid the trace of the previous mouse position */
      /* we hide it during the display,                    */
      /* and show it when the line has been displayed.     */
      hide_the_mouse();               textattr(colour2);
      gotoxy(37,2);                    cputs(" Ŀ ");
      gotoxy(37,3);                    cputs("                  ");
      gotoxy(37,4);                    cputs("                  ");
      gotoxy(37,5);                    cputs("                  ");
      gotoxy(37,6);                    cputs("                  ");
      gotoxy(37,7);                    cputs("                  ");
      gotoxy(37,8);                    cputs("                  ");
      gotoxy(37,9);                    cputs("                  ");
      gotoxy(37,10);                   cputs("                  ");
      gotoxy(37,11);                   cputs("                  ");
      gotoxy(37,12);                   cputs("                  ");
      gotoxy(37,13);                   cputs("  ");
      display_key_letter6();           display_menu_line6();
      show_the_mouse();
    }
 /*----------------*
  * MENU MANAGER 6 *
  *----------------*/
  int menu_manager6()
    {
      restore_screen();                return1=0;
      while(1){
        display_menu6();               return1=menu_choice6();
        if(return1==-2)                return(-2);
        if(return1==-1)                return(-1);
        if(return1==22)                choice_display_help6();
        display_menu6();
        if(return1==1){
          /* We execute the selected function */
	  if(menu6==10){
            /* We want to quit the sub-program */
	    return(-1);
	  }
	  if(menu6==1){
	    /*  */

	  }
	  if(menu6==2){
	    /*  */

	  }
	  if(menu6==3){
	    /*  */

	  }
	  if(menu6==4){
	    /*  */

	  }
	  if(menu6==5){
	    /*  */

	  }
	  if(menu6==6){
	    /*  */

	  }
	  if(menu6==7){
	    /*  */

	  }
	  if(menu6==8){
	    /*  */

	  }
	  if(menu6==9){
	    /*  */

	  }
	}
      }
    }
/* End of the Module *//*----------------*/
